<?php

namespace Drupal\noahs_page_builder\Plugin\Control;

/**
 * @ControlPlugin(
 *   id = "noahs_padding",
 *   label = @Translation("Padding")
 * )
 */
class ControlNoahsPadding extends ControlBase {

  /**
   * {@inheritdoc}
   */
  public function getype() {
    return 'noahs_padding';
  }

  /**
   * {@inheritdoc}
   */
  public function contentTemplate(array $params = []) {
    $data = $params['data'] ?? NULL;
    $name = $params['name'] ?? NULL;
    $value = $params['value'] ?? NULL;
    $output = '';

    $output .= '<div class="nohas-field-description">Use your property as px, em, rem, %, ...</div>';
    $output .= '<ul class="field-element-list-horizontal">';
    $output .= '<li>';
    $output .= '<input type="text" name="' . htmlspecialchars($name, ENT_QUOTES, 'UTF-8') . '[padding_left]" data-style-css="padding-left" value="' . (!empty($value['padding_left']) ? htmlspecialchars($value['padding_left'], ENT_QUOTES, 'UTF-8') : '') . '" class="form-control" field-settings>';
    $output .= '<label for="noahs_page_builder_padding_left">Left</label>';
    $output .= '</li>';
    $output .= '<li>';
    $output .= '<input type="text" name="' . htmlspecialchars($name, ENT_QUOTES, 'UTF-8') . '[padding_top]" data-style-css="padding-left" value="' . (!empty($value['padding_top']) ? htmlspecialchars($value['padding_top'], ENT_QUOTES, 'UTF-8') : '') . '" class="form-control" field-settings>';
    $output .= '<label for="noahs_page_builder_padding_top">Top</label>';
    $output .= '</li>';
    $output .= '<li>';
    $output .= '<input type="text" name="' . htmlspecialchars($name, ENT_QUOTES, 'UTF-8') . '[padding_right]" data-style-css="padding-left" value="' . (!empty($value['padding_right']) ? htmlspecialchars($value['padding_right'], ENT_QUOTES, 'UTF-8') : '') . '" class="form-control" field-settings>';
    $output .= '<label for="noahs_page_builder_padding_right">Right</label>';
    $output .= '</li>';
    $output .= '<li>';
    $output .= '<input type="text" name="' . htmlspecialchars($name, ENT_QUOTES, 'UTF-8') . '[padding_bottom]" data-style-css="padding-left" value="' . (!empty($value['padding_bottom']) ? htmlspecialchars($value['padding_bottom'], ENT_QUOTES, 'UTF-8') : '') . '" class="form-control" field-settings>';
    $output .= '<label for="noahs_page_builder_padding_bottom">Bottom</label>';
    $output .= '</li>';
    $output .= '</ul>';

    return $output;
  }

  /**
   * {@inheritdoc}
   */
  public function getDefaultSettings() {
    return [
      'input_type' => 'noahs_padding',
      'placeholder' => '',
      'title' => '',
    ];
  }

}
